/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////

// 5.10

{   			// extracode
#include <stdio.h>
#include <stdlib.h>
}

type file
{
	int   Goto;
public:
	char *FileName;
	FILE *Fd;
	long  BufLen;
	file(char *f = "") { FileName = f; Fd = 0; BufLen = 0; Goto = 0; }
}
[
	state public open closed ioDone jobDone;
	message public Open {char *} 
		       Close
		       Read 
		       Write {char *};

	trigger  { 
                  if ( Goto )
                  {
                    Goto = 0;
                    cerr << "\n\t\t\t-- goto >>>>>> ";
                  }
                  else
                    cerr << "\n<<<<<< shift ";
                  cerr << TopStackSymbol(0); 
                 };

	reductor { 
                  long depth = TopStack(-1);
                  cerr << "\n\n stack content: \t";
                  while ( depth-- > 0 )
                    cerr << TopStackSymbol(depth) << "\n\t\t\t";
                  cerr << "-- reduce stack by " << $#; 
                  Goto = 1;
                 };

	LIFE : jobDone+;
	jobDone : open ioDone closed;
	open    : Open
			{Fd = fopen(FileName, "w+");
			 BufLen = atol($1);};
	closed  : Close
			{(void)fclose(Fd); Fd = 0;};
	ioDone  : <
		   Read
		  |
		   Write {(void)fputs($1, Fd); fputs(" ", Fd);}
		  >*;
];

file { FileName = "t510.exr"; } t510;
