/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////

// 5.12.2

{
#include <stdio.h>
#include <stdlib.h>
}

type file
{
public:
	char *FileName;
	FILE *Fd;
	long WriteCount;
	file(char *f = "") { FileName = f; Fd = 0; WriteCount = 0; }
}
[
	state public open closed ioDone jobDone;
	message public Open 
		       Close
		       Read 
		       Write {char *};

	LIFE : jobDone+;
	jobDone : open ioDone closed;
	open    : Open {Fd = fopen(FileName, "w+");};
	closed  : Close
			{(void)fclose(Fd); Fd = 0;};
	ioDone  : <
		   Read
		  |
		   Write {(void)fputs($1, Fd); ++WriteCount;}
		  >*;
];

type data(file l1, file l2)
[
	state public on off;
	message public Open {char *} Close;

	LIFE : <on | off>+;

	on   : Open (->);

	off  : Close (->);
];


file { FileName = "t5122_1.exr"; } t5122_1,
     { FileName = "t5122_2.exr"; } t5122_2;

data(t5122_1, t5122_2) p5122;
