/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////

// 5.12.4

{
#include <stdio.h>
#include <stdlib.h>
}

type file
{
public:
	char *FileName;
	FILE *Fd;
	long  BufLen;
	file(char *f = "") { FileName = f; Fd = 0; BufLen = 0; }
}
[
	state public open closed ioDone jobDone;
	message public Open {char *} Close
		       Read {char *} Write {char *};

	LIFE : jobDone+;
	jobDone : open ioDone closed;
	open    : Open
			{Fd = fopen(FileName, "w+");
			 BufLen = atol($1);};
	closed  : Close
			{(void)fclose(Fd); Fd = 0;};
	ioDone  : <
		   Read {(void)fgets($1, BufLen, Fd);}
		  |
		   Write {(void)fputs($1, Fd);}
		  >*;
];

type data(file l1, file l2)
[
	state public on off;
	message public Open {char *} Close;

	LIFE : <on | off>+;

	on   : Open (->)
	       <
		open@l1 open@l2
		|
		open@l2 open@l1
	       >;

	off  : Close (->)
	       <
		closed@l1 closed@l2
		|
		closed@l2 closed@l1
	       >;
];


file { FileName = "f1.t5124"; } f1,
     { FileName = "f2.t5124"; } f2;

data(f1, f2) p;
