#/////////////////////////////////////////////////////////////
#//                                                         //
#// Copyright 1994, 1995, 1996                              //
#// MASTER INFORMATION SYSTEMS CORPORATION                  //
#// MUSKOX Version 1.2					    //
#// All Rights Reserved                                     //
#//                                                         //
#/////////////////////////////////////////////////////////////

#
# t5151 make file
# ----- ---- ----

framework_o = nodus.o pc.o 
engine_o    = inpus.o skeletus.o skelbmon.o generus.o

framework_h = bml.h nodus.h pc.h
engine_h    = atribus.h inpus.h skeletus.h skelbmon.h generus.h

#
# Build the MUSKOX ARM t5151
#

t5151:			t5151.o $(framework_o) $(engine_o)
			$(CCPLUS) $(CCFLAGS) -o t5151 t5151.o $(framework_o) $(engine_o)

#
# Compile framework
#

nodus.o:		nodus.$(CPP) $(framework_h) $(engine_h)
			$(CCPLUS) $(CCFLAGS) -c nodus.$(CPP)

pc.o:			pc.$(CPP) $(framework_h) $(engine_h)
			$(CCPLUS) $(CCFLAGS) -c pc.$(CPP)

#
# Compile engine
#

skeletus.o:		skeletus.$(CPP) $(engine_h)
			$(CCPLUS) $(CCFLAGS) -c skeletus.$(CPP)

skelbmon.o:		skelbmon.$(CPP) $(framework_h) $(engine_h)
			$(CCPLUS) $(CCFLAGS) -c skelbmon.$(CPP)

inpus.o:		inpus.$(CPP) $(engine_h)
			$(CCPLUS) $(CCFLAGS) -c inpus.$(CPP)

generus.o:		generus.$(CPP) $(engine_h)
			$(CCPLUS) $(CCFLAGS) -c generus.$(CPP)

#
# Compile mapped specs
#

t5151.o:		t5151.$(CPP) t5151.h $(framework_h) $(engine.h)
			$(CCPLUS) $(CCFLAGS) -c t5151.$(CPP)

#
# Run the MUSKOX compiler -- generate mapped specs
#

t5151.$(CPP):		t5151.ms t514.ms
			mskx -tvbjcu t5151.ms

