/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////

// 5.15.2

attach <t514.ms>


type updateFile : public file
{
public:
  char ReadBuffer[256];
  updateFile(char *f = "") : file(f) {};
}
[
  message public OpenForUpdate Read Seek {char *};
  state   public updateDone update more;
  trigger OpenForUpdate { Open("r+"); }
          Read          { (void)fgets(ReadBuffer, 256, Fd); 
                          cerr << endl << ReadBuffer; }
	  Seek          { (void)fseek(Fd, atol($$), 0); };

  LIFE : createFile+ update+;

  update : OpenForUpdate updateDone Close;

  updateDone  : 
              | Write+ more-
              | Read+  more-
              | more
              ;

  virtual public update
  [
      more    : Seek+			// right-recursive rules
              | Seek+ Write+ more-
              | Seek+ Read+  more-
              ;
  ];
];


type updateFile2 : public updateFile
[
  state public io;

  virtual public update
  [
     more : Seek+
          | io
          ;

     io   : Seek+ Write+	// left-recursive rules
          | Seek+ Read+
          | io Seek+ Write+
          | io Seek+ Read+
          ;
  ];
];
updateFile2 { FileName = "t5152.exr"; } t5152;
