#/////////////////////////////////////////////////////////////
#//                                                         //
#// Copyright 1994, 1995, 1996                              //
#// MASTER INFORMATION SYSTEMS CORPORATION                  //
#// MUSKOX Version 1.2					    //
#// All Rights Reserved                                     //
#//                                                         //
#/////////////////////////////////////////////////////////////

#
# t55 make file
# --- ---- ----

framework_o = nodus.o pc.o 
engine_o    = inpus.o skeletus.o skelbmon.o generus.o

framework_h = bml.h nodus.h pc.h
engine_h    = atribus.h inpus.h skeletus.h skelbmon.h generus.h

#
# Build the MUSKOX ARM t55
#

t55:			t55.o $(framework_o) $(engine_o)
			$(CCPLUS) $(CCFLAGS) -o t55 t55.o $(framework_o) $(engine_o)

#
# Compile framework
#

nodus.o:		nodus.$(CPP) $(framework_h) $(engine_h)
			$(CCPLUS) $(CCFLAGS) -c nodus.$(CPP)

pc.o:			pc.$(CPP) $(framework_h) $(engine_h)
			$(CCPLUS) $(CCFLAGS) -c pc.$(CPP)

#
# Compile engine
#

skeletus.o:		skeletus.$(CPP) $(engine_h)
			$(CCPLUS) $(CCFLAGS) -c skeletus.$(CPP)

skelbmon.o:		skelbmon.$(CPP) $(framework_h) $(engine_h)
			$(CCPLUS) $(CCFLAGS) -c skelbmon.$(CPP)

inpus.o:		inpus.$(CPP) $(engine_h)
			$(CCPLUS) $(CCFLAGS) -c inpus.$(CPP)

generus.o:		generus.$(CPP) $(engine_h)
			$(CCPLUS) $(CCFLAGS) -c generus.$(CPP)

#
# Compile mapped specs
#

t55.o:			t55.$(CPP) t55.h $(framework_h) $(engine.h)
			$(CCPLUS) $(CCFLAGS) -c t55.$(CPP)

#
# Run the MUSKOX compiler -- generate mapped specs
#

t55.$(CPP):		t55.ms
			mskx -tvbjcu t55.ms

