/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////

// 6.1.4

{
#include <stdlib.h>
}

type err
{
	public:
	virtual long UserRecover(ubrick *message)
	{
		if ( *message == Open || *message == Close )
		{
			cerr << endl << "Message <" << GetSymbol(*message)
			     << "> out of order";
		}
		else
		{
			cerr << endl << "Unknown message arrived, exit ARM";
			exit(1);
		}
		return 0;
	}
}
[
	state   public open closed;
	message public Open Close;

	trigger Open  { cerr << endl << "Open arrived"; }
		Close { cerr << endl << "Close arrived"; };

	begin closed;				// initial state

	LIFE   : open | closed;
	open   : closed Open;
	closed : open Close;
];

err t614;
